export default odaMethod({
    allowAccess: 'R', //todo replace 'R' to needs access of R, W, C, D, A
    icon: 'odant:method', //todo replace icon to needs
    props: {
        label:"Create structure",
        showOnServiceBar: true,
    },
    get allowUse() {
         return true; // todo: replace 'true' to needs conditions...
    },
    _isRunning: false,
    //export: true, // todo: uncomment for allow export
    async execute(params) {
    	if (this._isRunning) return;
    	
    	this._isRunning = true;
    	
    	await ODA.import('@oda/icon');
    	await ODA.tryReg('oda-icon');
	    const loader = document.createElement('oda-icon');
	    loader.textContent = 'В процессе';
	    loader.icon = 'odant:spin';
    	loader.fill = 'var(--info-color)';
	    loader.style = 'position: fixed;top: 50%;left: 50%;z-index: 100;transform: translate3d(-50%, -50%, 0);pointer-events: none;opacity: .5;';
	    loader.iconSize = 64;
	    document.body.appendChild(loader);
	    
    	let countCreatedBases = 0, countCreatedClasses = 0, countCreatedObjects = 0;
    	let $baseToRemove, $classToRemove, $objectToRemove;
    	for (let i = 1; i <= 3; i++) {
	        $baseToRemove = await this.$owner._createDomain({ Name: `base-${i}` }, 'B', true);
	        await $baseToRemove.load();
	        countCreatedBases++;
	    
	    	for (let j = 1; j <= 3; j++) {    
		        const $class = await $baseToRemove._createClass({ Name: `class-${i}.${j}` }, 'C', true);
		        if (!$classToRemove && (j === 2))
		        	$classToRemove = $class;
		        await $class.load();
		        countCreatedClasses++;
		        
		        const $FIELDS = $class.$FIELDS;
		        await $FIELDS.load();
		        
		        const $field = await $FIELDS.createField({ Name: 'n', Label: '№', Type: 'Numeric'});
		        await $class.save();
		        
		        for (let k = 1; k <= 9; k++) {   
		        	const $object = await $class.createObject();
		        	if (!$objectToRemove)
		        		$objectToRemove = $object;
		        		
	        		countCreatedObjects++;
		        	$object.data.n = '${i}${j}${k}';
		        	await $object.save();
		        }
	    	}
    	}
    	
    	await $objectToRemove.delete();
    	await $classToRemove.delete();
    	await $baseToRemove.delete();
    	
    	await ODA.import('@oda/table');
    	await ODA.tryReg('oda-table');
    	const table = await ODA.createComponent('oda-table');
    	table.columns = [{ name: 'name', label: 'Создано' }, { name: 'count', label: 'Количество' }];
    	table.dataSet = [
    		{ name: 'Создано баз', count: countCreatedBases },
    		{ name: 'Создано классов', count: countCreatedClasses },
    		{ name: 'Создано объектов', count: countCreatedObjects },
    		{ name: 'Удалено баз', count: 1 },
    		{ name: 'Удалено классов', count: 1 },
    		{ name: 'Удалено объектов', count: 1 },
    	];
    	table.style = 'height: 200px;';
    	
    	this._isRunning = false;
	    document.body.removeChild(loader);
    	
    	return ODA.showModal(table, {}, { title: 'Результат' });
    	
        // await $object.findAction('form');
        // await ODA.tryReg('odant-form');
        // const form = await ODA.createComponent('odant-form');
        // form.contextItem = $object;
        // await form.show();
        
        // return $object;
    },
})